/****************************************************
 *
 *	iter2 : Extended "iter" object for Max/MSP
 *
 *			copyright(c) 2004-2006 Shigeyuki Hirai
 *
 ****************************************************/
#include "ext.h"

void *iter2_class;

typedef struct {
	t_object x_obj;
	void *m_out;
	void *m_carryout;
} t_iter2;

void iter2_list(t_iter2 *x, t_symbol *msg, short argc, t_atom *argv);
void iter2_int(t_iter2 *x, long n);
void iter2_float(t_iter2 *x, float f);
void *iter2_new(void);

void iter2_list(t_iter2 *x, t_symbol *msg, short argc, t_atom *argv)
{
	int i;
	t_atom a;
	for (i=0; i<argc; i++, argv++) {
		switch (argv->a_type) {
		case A_LONG:
			outlet_int(x->m_out, argv->a_w.w_long); break;
		case A_FLOAT:
			outlet_float(x->m_out, argv->a_w.w_float); break;
//		case A_SYM:
//			post ("%s", argv[i].a_w.w_sym); break;
		}
	}
	outlet_bang(x->m_carryout);
}

void iter2_int(t_iter2 *x, long n)
{
	outlet_int(x->m_out, n);
	outlet_bang(x->m_carryout);
}

void iter2_float(t_iter2 *x, float f)
{
	outlet_float(x->m_out, f);
	outlet_bang(x->m_carryout);
}

void *iter2_new(void)
{
	t_iter2 *x = (t_iter2 *)newobject(iter2_class);
	x->m_carryout = bangout(x);
	x->m_out = intout(x);
	return (x);
}

/**********************************************************************************************
 *	
 **********************************************************************************************/
void main(fptr *f)
{
	
	setup((Messlist **)&iter2_class, 
			(method)iter2_new, 
			0L, 
			(short)sizeof(t_iter2), 
			0L, 
			0);
			
	addmess((method)iter2_list, "list", A_GIMME, 0);
	addint((method)iter2_int);
	addfloat((method)iter2_float);
}
